`include "defines.vh"
module interrupt_controller #(
        parameter   DATA_WIDTH = 8,
        parameter I_ADDR_WIDTH = 10
    )(
        input wire                    clk,
        input wire                    reset,
        input wire   [DATA_WIDTH-1:0] mem_tifr,
        input wire   [DATA_WIDTH-1:0] mem_timsk,
        input wire   [DATA_WIDTH-1:0] mem_sreg,
        output reg                    irq,
        output reg [I_ADDR_WIDTH-1:0] vector
    );

    wire [DATA_WIDTH-1:0] if_ext;
    wire [DATA_WIDTH-1:0] int_src;

    /* Extend the I flag in SREG to 8 bits: 0x00 or 0xFF
     * in order to use it as an and-mask */
    assign if_ext  = {DATA_WIDTH{mem_sreg[`FLAGS_I]}};
    assign int_src = mem_tifr & mem_timsk & if_ext;

    always @(posedge clk) begin
        if (reset) begin
            irq    <= 0;
            vector <= 0;
			end
			else begin
			// TODO 1: Setati irq si vector pentru evenimentele OCF0A, OCF0B si TOV0.
			// irq should be 1 (on) if any interrupt fired and vector should point to the address where 
			// the handler is stored. Please check defines.vh
			// As an example OCF0A interrupt flag should trigger irq = 1 and vector = TIM0_COMPA_ISR
			end
	end
			

endmodule
